//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 C'0,70,0'
#property indicator_color2 C'70,0,0'
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern int       RibbonShift = 0;
extern int       MA1Period=13;
extern int       MA1Method=MODE_SMA;
extern int       MA1Price =PRICE_CLOSE;
extern int       MA2Period=26;
extern int       MA2Method=MODE_SMA;
extern int       MA2Price =PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer3); SetIndexShift(0,RibbonShift); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer4); SetIndexShift(1,RibbonShift); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1); SetIndexShift(2,RibbonShift); 
   SetIndexBuffer(3,buffer2); SetIndexShift(3,RibbonShift); 
      MA1Method = MathMin(MathMax(MA1Method,0),4);
      MA2Method = MathMin(MathMax(MA2Method,0),4);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      if (MA1Method<4) 
            buffer1[i] = iMA(NULL,0,MA1Period,0,MA1Method,MA1Price,i);
      else  buffer1[i] = iLsma(iMA(NULL,0,1,0,MODE_SMA,MA1Price,i),MA1Period,i,0);
      if (MA2Method<4) 
            buffer2[i] = iMA(NULL,0,MA2Period,0,MA2Method,MA2Price,i);
      else  buffer2[i] = iLsma(iMA(NULL,0,1,0,MODE_SMA,MA2Price,i),MA2Period,i,1);
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workLsma[][2];
double iLsma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workLsma,0)!= Bars) ArrayResize(workLsma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
   
      period = MathMax(period,1);
      workLsma[r][instanceNo] = price;
         double lwmw = period; double lwma = lwmw*price;
         double sma  = price;
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   lwmw  += weight;
                   lwma  += weight*workLsma[r-k][instanceNo];  
                   sma   +=        workLsma[r-k][instanceNo];
         }             
   
   return(3.0*lwma/lwmw-2.0*sma/period);
}

